/*
 cs_dialogs.h
  MyCSeries include for platform dialogs

  Version 0.4

  Created: November 5, 2004
  Revised: August 2, 2006


    Version 1.0 has not yet been reached. If you have a name conflict,
  please feel free to contact me via E-mail with a list of alternative
  names, so the name conflict can be resolved by the next release.
*/

/*
 * THIS SOFTWARE IS NOT COPYRIGHTED
 *
 *  This source code is offered for use in the public domain.  You may use,
 * modify or distribute it freely.
 *
 *  This code is distributed in the hope that it will be useful but WITHOUT
 * ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY DISCLAIMED.
 *  This includes but is not limited to warranties of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef __CS_DIALOGS_H
# define __CS_DIALOGS_H

# include <cseries.h>

# if PRAGMA_ONCE
#  pragma once
# endif

# ifdef __cplusplus
   extern "C" {
# endif

# if PRAGMA_IMPORT
#  pragma import on
# endif

/* ------- constants */

  enum
  {
    /* alert types */
     fatalError = 0,
     infoError
  };

/* ------- typedefs */

# if TARGET_OS_MAC || defined(__MACTYPES__)
#  define platform_dialogref         DialogRef
# else
#  define platform_dialogref         void*
# endif

/* ------- prototypes */

 /* note that when `strID' is 128 and `index' is 0, then `_out_of_memory'
   overrides the resulting error string */
  EXTERN_API_C(void)
   alert_user(int alertType, short strID, int index, short err);

# if TARGET_OS_MAC
#  ifndef __DIALOGS__
#   include <Dialogs.h>
#  endif
# endif

  EXTERN_API_C(void)
   insert_int_into_text_item(platform_dialogref dlg, int item, int value);
  EXTERN_API_C(int)
   extract_int_from_text_item(platform_dialogref dlg, int item);

  EXTERN_API_C(void)
   animate_dialog_button(platform_dialogref dlg, int item);

# ifdef PRAGMA_IMPORT_OFF
#  pragma import off
# elif PRAGMA_IMPORT
#  pragma import reset
# endif

# ifdef __cplusplus
   }
# endif
#endif /*!defined(__CS_DIALOGS_H)*/
