#if 0
#  This is a C/MPW script hybrid!
# Just execute this on the command line, as is - Really!
#
# This MPW script is only used to test macintosh_cseries.a in the process
#   of updating (bug fixes, etc.).
# It builds an MPW tool and Echo's the tool name on the command line.

# WARNING: the tool generated requires an FPU (or emulator)

# This scripts parameters are:
#  atest [options]
#   -a              assemble macintosh_cseries.a and link only
#   -r              _only_ do random tests (no building) - 14 tests
#   -t[horough]     after building, do a thorough test of all math functions
#
#  (thorough testing option may take a while and cost about 78K of disk space)

# The tools parameters are:
#  atest  [options]  hi32 lo32
#   -d              enter the debugger
#   -dh             dont display hi32 results
#   -t              build the most recent table
#   -r              remapping test
#   -c              comparison test
#   -s              string test
#   -m              memxxx test

Unset 1 ; (Evaluate "{0}"=~/()1./)  dev:null ; Set Targ "{1}"
Unset 2 ; (Evaluate "{0}"=~/()2:/)  dev:null

If "{1}"=="-r"
  "{Targ}" ; "{Targ}" ; "{Targ}" ; "{Targ}" ; "{Targ}" ; "{Targ}" ; "{Targ}" ; "{Targ}"
  "{Targ}" ; "{Targ}" ; "{Targ}" ; "{Targ}" ; "{Targ}" ; "{Targ}" ; "{Targ}" ; "{Targ}"
  Exit 0
End

If NOT `Exists "{2}"::Obj:macintosh_cseries.a.o` OR "{1}"=="-a"
  If "{1}"!="-a"
    Echo '# Warning: :Obj:macintosh_cseries.a.o does not already exist.' ; Echo '# Attempting to "Make" it...'
  End
  Begin ; Make :Obj:macintosh_cseries.a.o ; End > "{2}":my_io.c.o.makeout
  "{2}":my_io.c.o.makeout
  Delete "{2}":my_io.c.o.makeout
End
If "{1}"!="-a" OR NOT `Exists "{2}"::Obj:macintosh_cseries.a.o`
  SC "{0}" -o "{0}".o -i :: -sym off -mc68881 -mc68040 -b2 -proto strict -i "{2}":::include:
End
ILink -o "{Targ}" "{2}"::Obj:macintosh_cseries.a.o "{0}".o -mf -t 'MPST' -c 'MPS ' -model far 
  "{Libraries}"MacRuntime.o "{CLibraries}"StdCLib.o 
  "{Libraries}"Interface.o "{Libraries}"IntEnv.o 
  -sn STDCLIB=Main -sn STDIO=Main -sn INTENV=Main -sn %A5Init=Main -sn SADEV=Main 
  -sn SANELIB=Main -state nouse -compact -pad 0
Echo -n "{Targ} " ; Exit 0
#Link -o atest macintosh_cseries.a.o atest.c.o "{Libraries}"MacRuntime.o "{Libraries}"Interface.o
#SetFile atest -t APPL -c '????' -a B

If "{1}"=="-t" OR "{1}"=="-thorough"
  Set TestResults "{TempFolder}Test Results"
  Open -n "{TestResults}"
  SaveOnClose -n "{TestResults}"
  Set t 4 ; Set u 4
  Begin
    Echo "# Performing thorough testing..."
    "{Targ}" 1 -65537 ; "{Targ}" -1 -1 ; "{Targ}" 3 2 ; "{Targ}" 12345 4
    "{Targ}" 2147483648 3221225472
    Loop
      Evaluate t += {u}2
      "{Targ}" -dh `evaluate {t}-1` ; "{Targ}" -dh {t} ; "{Targ}" -dh `evaluate {t}+1`
      Evaluate t += {u}2
      "{Targ}" -dh `evaluate {t}-1` ; "{Targ}" -dh {t} ; "{Targ}" -dh `evaluate {t}+1`
      Evaluate u *= 2
      If {t}>=268435456 ; Break ; End
    End
    Set t 276824064
    Loop
      "{Targ}" -dh `evaluate {t}-1` ; "{Targ}" -dh {t} ; "{Targ}" -dh `evaluate {t}+1`
      Evaluate t += 16777216
      If ({t}>0) AND ({t}<16777216) ; Break ; End
    End
    Echo "# Performing random tests..."
    "{Targ}" ; "{Targ}" ; "{Targ}" ; "{Targ}" ; "{Targ}" ; "{Targ}" ; "{Targ}" ; "{Targ}"
  End  "{TestResults}"
Else
  Echo -n "atest -d" # -1 -1"
End
Exit 0
#endif
/*
 atest.c

  For MyCSeries version 0.3

  Created: December 22, 2005 6:47 AM EDST
*/

#include <cs_strings.h>
#include <cs_text.h>

#include <OSUtils.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

char temporary[384] = "TRDs, 123[{]}\\|:;'\",<.>/?";
char bigStr[258] = "0123456789a123456789b123456789c123456789d123456789e\
123456789f123456789g123456789h123456789i123456789j123456789k123456789l123456789m\
123456789n123456789o123456789p123456789q123456789r123456789s123456789t123456789u\
123456789v123456789w123456789x123456789y1234567";

UInt16 dumbStr2[] = {5,0,2,1,100,27};
UInt32 dumbStr4[] = {5,0,2,1,50,27};

//pascal void elems68k(const void *, short) = 0xA9EC;
extern UInt32 __sqrtu32(UInt32);
extern UInt32 __sqrtu64(UInt64);
extern UInt32 __fsqrtu32(UInt32);
extern UInt32 __fsqrtu64(UInt64);

static UInt32	rand32_seed;

static UInt32 rand32(void)
{
	UInt32			crap;

	rand32_seed = rand32_seed*0x41C64E6D+12345;
	crap = (rand32_seed>>16)&0x7FFF;
	rand32_seed = rand32_seed*0x41C64E6D+12345;
	crap |= (rand32_seed>>1)&0x3FFF8000;
	rand32_seed = rand32_seed*0x41C64E6D+12345;
	return crap ^= (rand32_seed<<30);
}

void main(int argc, char **argv)
{
	UInt64			v;
	UInt32			r;
	int				f = 1, t = FALSE;
	boolean			dh = TRUE;

	rand32_seed = TickCount();
	if (argc>1) if (!strcmp(argv[1],"-d"))
		{
			--argc, ++f;
			Debugger();
		}

	if (argc>1)
		if (!strcmp(argv[1],"-t"))
			--argc, ++f, t = TRUE;
		else if (!strcmp(argv[1],"-dh"))
			--argc, ++f, dh = FALSE;

	if (argc>1) if (!strcmp(argv[f],"-r"))
	{
		--argc, ++f;
		tblcpy((UInt8*)temporary,(UInt8*)temporary,sizeof(temporary),(UInt8*)bigStr);
		tblcpy2((UInt16*)temporary,dumbStr2,sizeof(dumbStr2)/2,(UInt16*)bigStr,80,-1);
		tblcpy4((UInt32*)temporary,dumbStr4,sizeof(dumbStr4)/4,(UInt32*)bigStr,80,-1);
	}

	if (argc>1 && !strcmp(argv[f],"-c"))
	{
		const char	*ut = cs_MacRoman_uppercase;

		--argc, ++f;
		r = tblcmp("","",ut);
		r = tblcmp("","gunk",ut);
		r = tblcmp("GUNK","",ut);
		r = tblcmp("GUNK","gunk",ut);
		r = tblcmp("GEE WHISTLE - NO GEE WHIZ","Gee WHISTLE - no gee whiz",ut);
		r = tblcmp("- NO! GEE-WIZ.  ;yes><0149*-+","- NO! Gee-wiz.  ;yes<>0149*",ut);
	}

	if (argc>1 && !strcmp(argv[f],"-s"))
	{
		--argc, ++f;
		cpstrcpy(temporary,"",-1);
		cpstrcpy(temporary,"",0);
		cpstrcpy(temporary,"",1);
		cpstrcpy(temporary,"for naught and alley",-1);
		cpstrcpy(temporary,"for naught and alley",0);
		cpstrcpy(temporary,"for naught and alley",1);
		cpstrcpy(temporary,bigStr,-1);
		bigStr[257] = 0;
		cpstrcpy(temporary,bigStr,-1);
		bigStr[256] = 0;
		cpstrcpy(temporary,bigStr,-1);
		bigStr[255] = 0;
		cpstrcpy(temporary,bigStr,-1);
		bigStr[254] = 0;
		cpstrcpy(temporary,bigStr,-1);
	}

	if (argc>1 && !strcmp(argv[f],"-m"))
	{
		--argc, ++f;
		r = (UInt32)memchrbit(bigStr,0x40,sizeof(temporary));
		r = memcntbit(bigStr,0x20,sizeof(temporary));
	}

	if (argc<=1)
	{
		SetInt64(v,rand32(),rand32());
	} else if (argc==2)
		SetInt64(v,0,atoi(argv[f]));
	else
		SetInt64(v,atoi(argv[f]),atoi(argv[f+1]));

	if (t)
	{
/* square root table */
		int				pitch = 0x100000, delta;
		UInt16			b0, b1;

		for(f=0x4080000,delta=1; f<=0x10000000; ) //while(f<1.0)
		{
			b0 = delta+__fsqrtu32(f); f += pitch;
			b1 = delta+__fsqrtu32(f); f += pitch;
			fprintf(stderr, "\t\tdc.l\t\t$%08X", (b0<<18)|(b1<<2));
			b0 = delta+__fsqrtu32(f); f += pitch;
			b1 = delta+__fsqrtu32(f); f += pitch;
			fprintf(stderr, ", $%08X", (b0<<18)|(b1<<2));
			b0 = delta+__fsqrtu32(f); f += pitch;
			b1 = delta+__fsqrtu32(f); f += pitch;
			fprintf(stderr, ", $%08X", (b0<<18)|(b1<<2));
			b0 = delta+__fsqrtu32(f); f += pitch;
			b1 = delta+__fsqrtu32(f); f += pitch;
			fprintf(stderr, ", $%08X\n", (b0<<18)|(b1<<2));
		}
		goto end;
	}

	r = __fsqrtu32(Int64Hi(v));
	if (dh)
		fprintf(stdout, "# __fsqrtu32(0x%08X) = 0x%X (#%u)\n", Int64Hi(v),r,r);
	r = __fsqrtu32(Int64Lo(v));
//	if (argc>2)
	fprintf(stdout, "# __fsqrtu32(0x%08X) = 0x%X (#%u)\n", Int64Lo(v),r,r);
	r = __fsqrtu64(v);
//	if (argc>2)
	if (argc!=2)
		fprintf(stdout, "# __fsqrtu64(0x%08X%08X) = 0x%X (#%u)\n", Int64Hi(v),Int64Lo(v),r,r);

	r = __sqrtu32(Int64Hi(v));
	if (dh)
		fprintf(stdout, "# __sqrtu32(0x%08X)  = 0x%X (#%u)\n", Int64Hi(v),r,r);
	r = __sqrtu32(Int64Lo(v));
//	if (argc>2)
	fprintf(stdout, "# __sqrtu32(0x%08X)  = 0x%X (#%u)\n", Int64Lo(v),r,r);
	r = __sqrtu64(v);
//	if (argc>2)
	if (argc!=2)
		fprintf(stdout, "# __sqrtu64(0x%08X%08X)  = 0x%X (#%u)\n", Int64Hi(v),Int64Lo(v),r,r);
end:
	exit(0);
}
